#!/bin/bash
#
# Musterlsung zur Unix-bung "Automatisierung" im Blockkurs Systemverwaltung
# an der Freien Universitt Berlin im Sommersemester 2007
#
# Daniel Bwetter <boesswet@inf.fu-berlin.de>
# 08.08.2007
#

# Alternativ-Lsung, die (fast) nur mit Shell-Funktionalitt arbeitet

PATH=/bin:/usr/bin

# Name der virtual-Datei
F_VIRTUAL=virtual
# Name der Passwort-Datei
F_PASSWD=passwd
# kleinste UID, die einen E-Mail-Alias bekommen soll
UID_MIN=1000

# virtual kopieren
if ! cp $F_VIRTUAL ${F_VIRTUAL}~ ; then

	echo "Konnte $F_VIRTUAL nicht nach ${F_VIRTUAL}~ sichern! Abbruch ..."
	exit 1
fi

# Kopf der virtual bis zum "#---END" retten:
rm -f $F_VIRTUAL
while read s ; do
	echo $s >> $F_VIRTUAL
	#if expr match "$s" "#---END" > /dev/null ; then
	if [ "$s" = "#---END" ] > /dev/null ; then
		break
	fi
done < $F_VIRTUAL~

# passwd durchgehen und fr alle uid>1000 Zeilen an die virtual anhngen
xifs=$IFS # IFS sichern
IFS=":" # Token-Trenner ist jetzt ":"
while read login passwd uid gid comment rest ; do
	if [ "$uid" -ge "$UID_MIN" ]; then
		echo ${comment//[[:space:]]/.}"@springfield.com " $login >> $F_VIRTUAL
	fi
done < $F_PASSWD
IFS=$xifs # IFS wier auf den Standard-Wert

